Index: uspace/app/nav/nav.c
===================================================================
--- uspace/app/nav/nav.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/nav.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,342 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/** @file Navigator.
+ *
+ * HelenOS file manager.
+ */
+
+#include <gfx/coord.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/fixed.h>
+#include <ui/filelist.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include "menu.h"
+#include "nav.h"
+#include "panel.h"
+
+static void wnd_close(ui_window_t *, void *);
+static void wnd_kbd(ui_window_t *, void *, kbd_event_t *);
+
+static ui_window_cb_t window_cb = {
+	.close = wnd_close,
+	.kbd = wnd_kbd
+};
+
+static void navigator_file_open(void *);
+static void navigator_file_exit(void *);
+
+static nav_menu_cb_t navigator_menu_cb = {
+	.file_open = navigator_file_open,
+	.file_exit = navigator_file_exit
+};
+
+static void navigator_panel_activate_req(void *, panel_t *);
+
+static panel_cb_t navigator_panel_cb = {
+	.activate_req = navigator_panel_activate_req
+};
+
+/** Window close button was clicked.
+ *
+ * @param window Window
+ * @param arg Argument (navigator)
+ */
+static void wnd_close(ui_window_t *window, void *arg)
+{
+	navigator_t *navigator = (navigator_t *) arg;
+
+	ui_quit(navigator->ui);
+}
+
+/** Window keyboard event handler.
+ *
+ * @param window Window
+ * @param arg Argument (navigator)
+ * @param event Keyboard event
+ */
+static void wnd_kbd(ui_window_t *window, void *arg, kbd_event_t *event)
+{
+	navigator_t *navigator = (navigator_t *) arg;
+
+	if (event->type == KEY_PRESS &&
+	    ((event->mods & KM_ALT) == 0) &&
+	    ((event->mods & KM_SHIFT) == 0) &&
+	    (event->mods & KM_CTRL) != 0) {
+		switch (event->key) {
+		case KC_Q:
+			ui_quit(navigator->ui);
+			break;
+		default:
+			break;
+		}
+	}
+
+	if (event->type == KEY_PRESS &&
+	    ((event->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)) {
+		switch (event->key) {
+		case KC_TAB:
+			navigator_switch_panel(navigator);
+			break;
+		default:
+			break;
+		}
+	}
+
+	ui_window_def_kbd(window, event);
+}
+
+/** Create navigator.
+ *
+ * @param display_spec Display specification
+ * @param rnavigator Place to store pointer to new navigator
+ * @return EOK on success or ane error code
+ */
+errno_t navigator_create(const char *display_spec,
+    navigator_t **rnavigator)
+{
+	navigator_t *navigator;
+	ui_wnd_params_t params;
+	gfx_rect_t rect;
+	gfx_rect_t arect;
+	gfx_coord_t pw;
+	unsigned i;
+	errno_t rc;
+
+	navigator = calloc(1, sizeof(navigator_t));
+	if (navigator == NULL)
+		return ENOMEM;
+
+	rc = ui_create(display_spec, &navigator->ui);
+	if (rc != EOK) {
+		printf("Error creating UI on display %s.\n", display_spec);
+		goto error;
+	}
+
+	ui_wnd_params_init(&params);
+	params.caption = "Navigator";
+	params.style &= ~ui_wds_decorated;
+	params.placement = ui_wnd_place_full_screen;
+
+	rc = ui_window_create(navigator->ui, &params, &navigator->window);
+	if (rc != EOK) {
+		printf("Error creating window.\n");
+		goto error;
+	}
+
+	ui_window_set_cb(navigator->window, &window_cb, (void *) navigator);
+	ui_window_get_app_rect(navigator->window, &arect);
+
+	rc = ui_fixed_create(&navigator->fixed);
+	if (rc != EOK) {
+		printf("Error creating fixed layout.\n");
+		goto error;
+	}
+
+	ui_window_add(navigator->window, ui_fixed_ctl(navigator->fixed));
+
+	rc = nav_menu_create(navigator->window, &navigator->menu);
+	if (rc != EOK)
+		goto error;
+
+	nav_menu_set_cb(navigator->menu, &navigator_menu_cb,
+	    (void *)navigator);
+
+	rc = ui_fixed_add(navigator->fixed, nav_menu_ctl(navigator->menu));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	/* Panel width */
+	pw = (arect.p1.x - arect.p0.x) / 2;
+
+	for (i = 0; i < 2; i++) {
+		rc = panel_create(navigator->window, i == 0,
+		    &navigator->panel[i]);
+		if (rc != EOK)
+			goto error;
+
+		rect.p0.x = arect.p0.x + pw * i;
+		rect.p0.y = arect.p0.y + 1;
+		rect.p1.x = arect.p0.x + pw * (i + 1);
+		rect.p1.y = arect.p1.y - 1;
+		panel_set_rect(navigator->panel[i], &rect);
+
+		panel_set_cb(navigator->panel[i], &navigator_panel_cb,
+		    navigator);
+
+		rc = ui_fixed_add(navigator->fixed,
+		    panel_ctl(navigator->panel[i]));
+		if (rc != EOK) {
+			printf("Error adding control to layout.\n");
+			goto error;
+		}
+
+		rc = panel_read_dir(navigator->panel[i], ".");
+		if (rc != EOK) {
+			printf("Error reading directory.\n");
+			goto error;
+		}
+	}
+
+	rc = ui_window_paint(navigator->window);
+	if (rc != EOK) {
+		printf("Error painting window.\n");
+		goto error;
+	}
+
+	*rnavigator = navigator;
+	return EOK;
+error:
+	navigator_destroy(navigator);
+	return rc;
+}
+
+void navigator_destroy(navigator_t *navigator)
+{
+	unsigned i;
+
+	for (i = 0; i < 2; i++) {
+		if (navigator->panel[i] != NULL) {
+			ui_fixed_remove(navigator->fixed,
+			    panel_ctl(navigator->panel[i]));
+			panel_destroy(navigator->panel[i]);
+		}
+	}
+
+	if (navigator->menu != NULL) {
+		ui_fixed_remove(navigator->fixed, nav_menu_ctl(navigator->menu));
+		nav_menu_destroy(navigator->menu);
+	}
+
+	if (navigator->window != NULL)
+		ui_window_destroy(navigator->window);
+	if (navigator->ui != NULL)
+		ui_destroy(navigator->ui);
+	free(navigator);
+}
+
+/** Run navigator on the specified display. */
+errno_t navigator_run(const char *display_spec)
+{
+	navigator_t *navigator;
+	errno_t rc;
+
+	rc = navigator_create(display_spec, &navigator);
+	if (rc != EOK)
+		return rc;
+
+	ui_run(navigator->ui);
+
+	navigator_destroy(navigator);
+	return EOK;
+}
+
+/** Get the currently active navigator panel.
+ *
+ * @param navigator Navigator
+ * @return Currently active panel
+ */
+panel_t *navigator_get_active_panel(navigator_t *navigator)
+{
+	int i;
+
+	for (i = 0; i < navigator_panels; i++) {
+		if (panel_is_active(navigator->panel[i]))
+			return navigator->panel[i];
+	}
+
+	/* This should not happen */
+	assert(false);
+	return NULL;
+}
+
+/** Switch to another navigator panel.
+ *
+ * Changes the currently active navigator panel to the next panel.
+ *
+ * @param navigator Navigator
+ */
+void navigator_switch_panel(navigator_t *navigator)
+{
+	errno_t rc;
+
+	if (panel_is_active(navigator->panel[0])) {
+		rc = panel_activate(navigator->panel[1]);
+		if (rc != EOK)
+			return;
+		panel_deactivate(navigator->panel[0]);
+	} else {
+		rc = panel_activate(navigator->panel[0]);
+		if (rc != EOK)
+			return;
+		panel_deactivate(navigator->panel[1]);
+	}
+}
+
+/** File / Open menu entry selected */
+static void navigator_file_open(void *arg)
+{
+	navigator_t *navigator = (navigator_t *)arg;
+	panel_t *panel;
+
+	panel = navigator_get_active_panel(navigator);
+	ui_file_list_open(panel->flist, ui_file_list_get_cursor(panel->flist));
+}
+
+/** File / Exit menu entry selected */
+static void navigator_file_exit(void *arg)
+{
+	navigator_t *navigator = (navigator_t *)arg;
+
+	ui_quit(navigator->ui);
+}
+
+/** Panel callback requesting panel activation.
+ *
+ * @param arg Argument (navigator_t *)
+ * @param panel Panel
+ */
+void navigator_panel_activate_req(void *arg, panel_t *panel)
+{
+	navigator_t *navigator = (navigator_t *)arg;
+
+	if (!panel_is_active(panel))
+		navigator_switch_panel(navigator);
+}
+
+/** @}
+ */
Index: uspace/app/nav/nav.h
===================================================================
--- uspace/app/nav/nav.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/nav.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator
+ */
+
+#ifndef NAV_H
+#define NAV_H
+
+#include <errno.h>
+#include "types/nav.h"
+#include "types/panel.h"
+
+extern errno_t navigator_create(const char *, navigator_t **);
+extern void navigator_destroy(navigator_t *);
+extern errno_t navigator_run(const char *);
+extern panel_t *navigator_get_active_panel(navigator_t *);
+extern void navigator_switch_panel(navigator_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nav/panel.c
===================================================================
--- uspace/app/nav/panel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/panel.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,452 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/** @file Navigator panel.
+ *
+ * Displays a file listing.
+ */
+
+#include <errno.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <stdlib.h>
+#include <task.h>
+#include <ui/control.h>
+#include <ui/filelist.h>
+#include <ui/paint.h>
+#include <ui/resource.h>
+#include "panel.h"
+#include "nav.h"
+
+static void panel_ctl_destroy(void *);
+static errno_t panel_ctl_paint(void *);
+static ui_evclaim_t panel_ctl_kbd_event(void *, kbd_event_t *);
+static ui_evclaim_t panel_ctl_pos_event(void *, pos_event_t *);
+
+/** Panel control ops */
+static ui_control_ops_t panel_ctl_ops = {
+	.destroy = panel_ctl_destroy,
+	.paint = panel_ctl_paint,
+	.kbd_event = panel_ctl_kbd_event,
+	.pos_event = panel_ctl_pos_event
+};
+
+static void panel_flist_activate_req(ui_file_list_t *, void *);
+static void panel_flist_selected(ui_file_list_t *, void *, const char *);
+
+/** Panel file list callbacks */
+static ui_file_list_cb_t panel_flist_cb = {
+	.activate_req = panel_flist_activate_req,
+	.selected = panel_flist_selected,
+};
+
+/** Create panel.
+ *
+ * @param window Containing window
+ * @param active @c true iff panel should be active
+ * @param rpanel Place to store pointer to new panel
+ * @return EOK on success or an error code
+ */
+errno_t panel_create(ui_window_t *window, bool active, panel_t **rpanel)
+{
+	panel_t *panel;
+	errno_t rc;
+
+	panel = calloc(1, sizeof(panel_t));
+	if (panel == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&panel_ctl_ops, (void *)panel,
+	    &panel->control);
+	if (rc != EOK) {
+		free(panel);
+		return rc;
+	}
+
+	rc = gfx_color_new_ega(0x07, &panel->color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x0f, &panel->act_border_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_file_list_create(window, active, &panel->flist);
+	if (rc != EOK)
+		goto error;
+
+	ui_file_list_set_cb(panel->flist, &panel_flist_cb, (void *)panel);
+
+	panel->window = window;
+	panel->active = active;
+	*rpanel = panel;
+	return EOK;
+error:
+	if (panel->color != NULL)
+		gfx_color_delete(panel->color);
+	if (panel->act_border_color != NULL)
+		gfx_color_delete(panel->act_border_color);
+	if (panel->flist != NULL)
+		ui_file_list_destroy(panel->flist);
+	ui_control_delete(panel->control);
+	free(panel);
+	return rc;
+}
+
+/** Destroy panel.
+ *
+ * @param panel Panel
+ */
+void panel_destroy(panel_t *panel)
+{
+	gfx_color_delete(panel->color);
+	gfx_color_delete(panel->act_border_color);
+	ui_control_delete(panel->control);
+	free(panel);
+}
+
+/** Set panel callbacks.
+ *
+ * @param panel Panel
+ * @param cb Callbacks
+ * @param arg Argument to callback functions
+ */
+void panel_set_cb(panel_t *panel, panel_cb_t *cb, void *arg)
+{
+	panel->cb = cb;
+	panel->cb_arg = arg;
+}
+
+/** Paint panel.
+ *
+ * @param panel Panel
+ */
+errno_t panel_paint(panel_t *panel)
+{
+	gfx_context_t *gc = ui_window_get_gc(panel->window);
+	ui_resource_t *res = ui_window_get_res(panel->window);
+	ui_box_style_t bstyle;
+	gfx_color_t *bcolor;
+	ui_control_t *ctl;
+	errno_t rc;
+
+	rc = gfx_set_color(gc, panel->color);
+	if (rc != EOK)
+		return rc;
+
+	rc = gfx_fill_rect(gc, &panel->rect);
+	if (rc != EOK)
+		return rc;
+
+	if (panel->active) {
+		bstyle = ui_box_double;
+		bcolor = panel->act_border_color;
+	} else {
+		bstyle = ui_box_single;
+		bcolor = panel->color;
+	}
+
+	rc = ui_paint_text_box(res, &panel->rect, bstyle, bcolor);
+	if (rc != EOK)
+		return rc;
+
+	ctl = ui_file_list_ctl(panel->flist);
+	rc = ui_control_paint(ctl);
+	if (rc != EOK)
+		return rc;
+
+	rc = gfx_update(gc);
+	if (rc != EOK)
+		return rc;
+
+	return EOK;
+}
+
+/** Handle panel keyboard event.
+ *
+ * @param panel Panel
+ * @param event Keyboard event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t panel_kbd_event(panel_t *panel, kbd_event_t *event)
+{
+	ui_control_t *ctl;
+
+	if (!panel->active)
+		return ui_unclaimed;
+
+	ctl = ui_file_list_ctl(panel->flist);
+	return ui_control_kbd_event(ctl, event);
+}
+
+/** Handle panel position event.
+ *
+ * @param panel Panel
+ * @param event Position event
+ * @return ui_claimed iff event was claimed
+ */
+ui_evclaim_t panel_pos_event(panel_t *panel, pos_event_t *event)
+{
+	gfx_coord2_t pos;
+	ui_control_t *ctl;
+	ui_evclaim_t claim;
+
+	pos.x = event->hpos;
+	pos.y = event->vpos;
+	if (!gfx_pix_inside_rect(&pos, &panel->rect))
+		return ui_unclaimed;
+
+	ctl = ui_file_list_ctl(panel->flist);
+	claim = ui_control_pos_event(ctl, event);
+	if (claim == ui_claimed)
+		return ui_claimed;
+
+	if (!panel->active && event->type == POS_PRESS)
+		panel_activate_req(panel);
+
+	return ui_claimed;
+}
+
+/** Get base control for panel.
+ *
+ * @param panel Panel
+ * @return Base UI control
+ */
+ui_control_t *panel_ctl(panel_t *panel)
+{
+	return panel->control;
+}
+
+/** Set panel rectangle.
+ *
+ * @param panel Panel
+ * @param rect Rectangle
+ */
+void panel_set_rect(panel_t *panel, gfx_rect_t *rect)
+{
+	gfx_rect_t irect;
+
+	panel->rect = *rect;
+
+	irect.p0.x = panel->rect.p0.x + 1;
+	irect.p0.y = panel->rect.p0.y + 1;
+	irect.p1.x = panel->rect.p1.x;
+	irect.p1.y = panel->rect.p1.y - 1;
+
+	ui_file_list_set_rect(panel->flist, &irect);
+}
+
+/** Determine if panel is active.
+ *
+ * @param panel Panel
+ * @return @c true iff panel is active
+ */
+bool panel_is_active(panel_t *panel)
+{
+	return panel->active;
+}
+
+/** Activate panel.
+ *
+ * @param panel Panel
+ *
+ * @return EOK on success or an error code
+ */
+errno_t panel_activate(panel_t *panel)
+{
+	errno_t rc;
+
+	rc = ui_file_list_activate(panel->flist);
+	if (rc != EOK)
+		return rc;
+
+	panel->active = true;
+	(void) panel_paint(panel);
+	return EOK;
+}
+
+/** Deactivate panel.
+ *
+ * @param panel Panel
+ */
+void panel_deactivate(panel_t *panel)
+{
+	ui_file_list_deactivate(panel->flist);
+	panel->active = false;
+	(void) panel_paint(panel);
+}
+
+/** Destroy panel control.
+ *
+ * @param arg Argument (panel_t *)
+ */
+void panel_ctl_destroy(void *arg)
+{
+	panel_t *panel = (panel_t *) arg;
+
+	panel_destroy(panel);
+}
+
+/** Paint panel control.
+ *
+ * @param arg Argument (panel_t *)
+ * @return EOK on success or an error code
+ */
+errno_t panel_ctl_paint(void *arg)
+{
+	panel_t *panel = (panel_t *) arg;
+
+	return panel_paint(panel);
+}
+
+/** Handle panel control keyboard event.
+ *
+ * @param arg Argument (panel_t *)
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t panel_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	panel_t *panel = (panel_t *) arg;
+
+	return panel_kbd_event(panel, event);
+}
+
+/** Handle panel control position event.
+ *
+ * @param arg Argument (panel_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t panel_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	panel_t *panel = (panel_t *) arg;
+
+	return panel_pos_event(panel, event);
+}
+
+/** Read directory into panel entry list.
+ *
+ * @param panel Panel
+ * @param dirname Directory path
+ * @return EOK on success or an error code
+ */
+errno_t panel_read_dir(panel_t *panel, const char *dirname)
+{
+	return ui_file_list_read_dir(panel->flist, dirname);
+}
+
+/** Request panel activation.
+ *
+ * Call back to request panel activation.
+ *
+ * @param panel Panel
+ */
+void panel_activate_req(panel_t *panel)
+{
+	if (panel->cb != NULL && panel->cb->activate_req != NULL)
+		panel->cb->activate_req(panel->cb_arg, panel);
+}
+
+/** Open panel file entry.
+ *
+ * Perform Open action on a file entry (i.e. try running it).
+ *
+ * @param panel Panel
+ * @param fname File name
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t panel_open_file(panel_t *panel, const char *fname)
+{
+	task_id_t id;
+	task_wait_t wait;
+	task_exit_t texit;
+	int retval;
+	errno_t rc;
+	ui_t *ui;
+
+	ui = ui_window_get_ui(panel->window);
+
+	/* Free up and clean console for the child task. */
+	rc = ui_suspend(ui);
+	if (rc != EOK)
+		return rc;
+
+	rc = task_spawnl(&id, &wait, fname, fname, NULL);
+	if (rc != EOK)
+		goto error;
+
+	rc = task_wait(&wait, &texit, &retval);
+	if ((rc != EOK) || (texit != TASK_EXIT_NORMAL))
+		goto error;
+
+	/* Resume UI operation */
+	rc = ui_resume(ui);
+	if (rc != EOK)
+		return rc;
+
+	(void) ui_paint(ui_window_get_ui(panel->window));
+	return EOK;
+error:
+	(void) ui_resume(ui);
+	(void) ui_paint(ui_window_get_ui(panel->window));
+	return rc;
+}
+
+/** File list in panel requests activation.
+ *
+ * @param flist File list
+ * @param arg Argument (panel_t *)
+ */
+static void panel_flist_activate_req(ui_file_list_t *flist, void *arg)
+{
+	panel_t *panel = (panel_t *)arg;
+
+	panel_activate_req(panel);
+}
+
+/** File in panel file list was selected.
+ *
+ * @param flist File list
+ * @param arg Argument (panel_t *)
+ * @param fname File name
+ */
+static void panel_flist_selected(ui_file_list_t *flist, void *arg,
+    const char *fname)
+{
+	panel_t *panel = (panel_t *)arg;
+
+	(void) panel_open_file(panel, fname);
+}
+
+/** @}
+ */
Index: uspace/app/nav/panel.h
===================================================================
--- uspace/app/nav/panel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/panel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup nav
+ * @{
+ */
+/**
+ * @file Navigator panel
+ */
+
+#ifndef PANEL_H
+#define PANEL_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+#include <ui/control.h>
+#include <ui/window.h>
+#include <stdbool.h>
+#include "types/panel.h"
+
+extern errno_t panel_create(ui_window_t *, bool, panel_t **);
+extern void panel_destroy(panel_t *);
+extern void panel_set_cb(panel_t *, panel_cb_t *, void *);
+extern errno_t panel_paint(panel_t *);
+extern ui_evclaim_t panel_kbd_event(panel_t *, kbd_event_t *);
+extern ui_evclaim_t panel_pos_event(panel_t *, pos_event_t *);
+extern ui_control_t *panel_ctl(panel_t *);
+extern void panel_set_rect(panel_t *, gfx_rect_t *);
+extern bool panel_is_active(panel_t *);
+extern errno_t panel_activate(panel_t *);
+extern void panel_deactivate(panel_t *);
+extern errno_t panel_read_dir(panel_t *, const char *);
+extern void panel_activate_req(panel_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/app/nav/test/main.c
===================================================================
--- uspace/app/nav/test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/test/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,37 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+
+PCUT_INIT;
+
+PCUT_IMPORT(menu);
+PCUT_IMPORT(nav);
+PCUT_IMPORT(panel);
+
+PCUT_MAIN();
Index: uspace/app/nav/test/menu.c
===================================================================
--- uspace/app/nav/test/menu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/nav/test/menu.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,166 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <errno.h>
+#include <pcut/pcut.h>
+#include <stdbool.h>
+#include "../menu.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(menu);
+
+static void test_menu_file_open(void *);
+static void test_menu_file_exit(void *);
+
+static nav_menu_cb_t dummy_cb;
+static nav_menu_cb_t test_cb = {
+	.file_open = test_menu_file_open,
+	.file_exit = test_menu_file_exit
+};
+
+/** Test response */
+typedef struct {
+	bool file_open;
+	bool file_exit;
+} test_resp_t;
+
+/** Create and destroy menu. */
+PCUT_TEST(create_destroy)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	nav_menu_t *menu;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = nav_menu_create(window, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	nav_menu_destroy(menu);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** nav_menu_set_cb() */
+PCUT_TEST(set_cb)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	nav_menu_t *menu;
+	int foo;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = nav_menu_create(window, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	nav_menu_set_cb(menu, &test_cb, &foo);
+	PCUT_ASSERT_EQUALS(&test_cb, menu->cb);
+	PCUT_ASSERT_EQUALS(&foo, menu->cb_arg);
+
+	nav_menu_destroy(menu);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** File / Open callback */
+PCUT_TEST(file_open)
+{
+	ui_t *ui;
+	ui_window_t *window;
+	ui_wnd_params_t params;
+	nav_menu_t *menu;
+	test_resp_t resp;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	ui_wnd_params_init(&params);
+	params.caption = "Test";
+
+	rc = ui_window_create(ui, &params, &window);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	rc = nav_menu_create(window, &menu);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	/* Call back with no callbacks set */
+	nav_menu_file_open(NULL, menu);
+
+	/* Call back with dummy callbacks set */
+	nav_menu_set_cb(menu, &dummy_cb, &resp);
+	nav_menu_file_open(NULL, menu);
+
+	/* Call back with test callbacks set */
+	resp.file_open = false;
+	nav_menu_set_cb(menu, &test_cb, &resp);
+	nav_menu_file_open(NULL, menu);
+	PCUT_ASSERT_TRUE(resp.file_open);
+
+	nav_menu_destroy(menu);
+	ui_window_destroy(window);
+	ui_destroy(ui);
+}
+
+/** Testing File / Open callback */
+static void test_menu_file_open(void *arg)
+{
+	test_resp_t *resp = (test_resp_t *)arg;
+
+	resp->file_open = true;
+}
+
+/** Testing File / Exit callback */
+static void test_menu_file_exit(void *arg)
+{
+	test_resp_t *resp = (test_resp_t *)arg;
+
+	resp->file_exit = true;
+}
+
+PCUT_EXPORT(menu);
